<?php

namespace Drupal\couchbasedrupal;

/**
 * Serializer that properly deals with
 * failed unserialization
 */
class IgbinarySerializer implements SerializerInterface {

  /**
   * Serialized FALSE
   *
   * @var string
   */
  protected $nullSerialized;

  public function __construct() {
    $this->nullSerialized = igbinary_serialize(NULL);
  }


  public function serialize($data) {
    return igbinary_serialize($data);
  }

  public function unserialize($data, bool &$success) {
    $success = TRUE;
	  if ($data == $this->nullSerialized) {
		  return NULL;
	  }
	  $result = @igbinary_unserialize($data);
	  if ($result === NULL) {
		  $success = FALSE;
		  return NULL;
	  }
	  return $result;
  }

}