<?php

namespace Drupal\couchbasedrupal;

/**
 * Serializer that properly deals with
 * failed unserialization
 */
class PhpSerializer implements SerializerInterface {

  /**
   * Serialized FALSE
   *
   * @var string
   */
  protected $falseSerialized;

  public function __construct() {
    $this->falseSerialized = serialize(FALSE);
  }

  public function serialize($data) {
    return serialize($data);
  }

  public function unserialize($data, bool &$success) {
    $success = TRUE;
	  if ($data == $this->falseSerialized) {
		  return FALSE;
	  }
	  $result = @unserialize($data);
	  if ($result === FALSE) {
		  $success = FALSE;
		  return NULL;
	  }
	  return $result;
  }

}